//------------------------------------------------------
//
//   Greg's Prospecting Mod - Client
//
//------------------------------------------------------

package net.minecraft.src;

//import java.util.Random;
//import java.util.Map;
import java.io.File;
import org.lwjgl.input.Keyboard;
import net.minecraft.client.Minecraft;
import net.minecraft.src.forge.MinecraftForgeClient;
import net.minecraft.src.forge.IItemRenderer;
import gcewing.prospecting.*;

public class mod_GregsProspecting extends GregsProspecting {

	public static Minecraft minecraft;
	public static File mcdir;
	
	static int debugTickCount = 0;
	
	public mod_GregsProspecting() {
		super(false);
	}

	public void load() {
		minecraft = ModLoader.getMinecraftInstance();
		mcdir = Minecraft.getMinecraftDir();
		super.load(mcdir);
		//addSounds();
		registerRenderers();
		registerKeys();
		ModLoader.setInGameHook(this, true, true);
	}
	
	public boolean onTickInGame(float tick, Minecraft game) {
//		Runtime r = Runtime.getRuntime();
//		int m1 = r.freeMemory();
		
		//System.out.printf("mod_GregsProspecting.onTickInGame\n");
		ItemSlimophone.onTick();
		
//		int m2 = r.freeMemory();
//		
//		debugTickCount += 1;
//		if (debugTickCount >= 20) {
//			debugTickCount = 0;
//			System.out.printf("mod_GregsProspecting.onTickInGame: used %d bytes\n",
//				m1 - m2);
//			
////			r.gc();
////			System.out.printf("mod_GregsProspecting.onTickInGame: free mem = %10d\n",
////				r.freeMemory());
//		}
		
		return true;
	}
	
//	void addSounds() {
//		minecraft.installResource("sound/gcewing/slimefilt1.ogg",
//			new File(mcdir, "gcewing/resources/prospecting/slimefilt1.ogg"));
//	}
	
	void registerRenderers() {
		IItemRenderer rmr = new RenderMiningRadar();
		addItemRenderer(miningRadar, rmr);
		addItemRenderer(colorMiningRadar, rmr);
		addItemRenderer(brokenMiningRadar, rmr);
		addItemRenderer(slimophone, new RenderSlimophone());
	}
	
	void addItemRenderer(Item item, IItemRenderer renderer) {
		MinecraftForgeClient.registerItemRenderer(item.shiftedIndex, renderer);
	}
	
	void registerKeys() {
		registerKey("Reduce Radar Range", Keyboard.KEY_LBRACKET);
		registerKey("Increase Radar Range", Keyboard.KEY_RBRACKET);
		registerKey("Radar Linear Mode", Keyboard.KEY_L);
		registerKey("Radar Discrimination Mode", Keyboard.KEY_M);
	}
	
	void registerKey(String desc, int code) {
		ModLoader.registerKey(this, new KeyBinding(desc, code), false);
	}
	
	public void keyboardEvent(KeyBinding binding) {
		//System.out.printf("keyboardEvent: %d %s\n",
		//	binding.keyCode, binding.keyDescription);
		switch (binding.keyCode) {
			case Keyboard.KEY_LBRACKET:
				sendMiningRadarAction(MiningRadarAction.DecreaseRange);
				break;
			case Keyboard.KEY_RBRACKET:
				sendMiningRadarAction(MiningRadarAction.IncreaseRange);
				break;
			case Keyboard.KEY_M:
				sendMiningRadarAction(MiningRadarAction.SelectDiscriminationMode);
				break;
			case Keyboard.KEY_L:
				sendMiningRadarAction(MiningRadarAction.SelectLinearMode);
				break;
		}
	}
	
	void sendMiningRadarAction(MiningRadarAction action) {
		EntityPlayer player = getPlayer();
		if (player != null && player.worldObj != null && player.worldObj.isRemote)
			sendPacket(new byte[] {0, (byte) action.ordinal()});
		else
			performMiningRadarAction(player, action);
	}
	
	static void sendPacket(byte[] data) {
		Packet250CustomPayload pkt = new Packet250CustomPayload();
		pkt.channel = channelName;
		pkt.length = data.length;
		pkt.data = data;
		System.out.printf("mod_GregsProspecting: Sending packet on channel %s\n",
			pkt.channel);
		//System.out.printf("mod_GregsProspecting: Data =");
		//for (int i = 0; i < pkt.length; i++)
		//	System.out.printf(" %02X", pkt.data[i]);
		//System.out.printf("\n");
		ModLoader.sendPacket(pkt);
	}
	
	public void receivePacket(Packet250CustomPayload pkt) {
		System.out.printf("mod_GregsProspecting: received packet on channel %s\n",
			pkt.channel);
	}
	
//	static World getWorld() {
//		return ModLoader.getMinecraftInstance().theWorld;
//	}
	
	static EntityPlayer getPlayer() {
		return ModLoader.getMinecraftInstance().thePlayer;
	}
	
//	static ItemStack getCurrentEquippedItem() {
//		return getPlayer().getCurrentEquippedItem();
//	}

}
